Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4752)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4753)
@@ -4528,50 +4178,228 @@
                 ENDDO
              ENDDO
-
-          CASE DEFAULT
-
-       END SELECT
-
-    END SUBROUTINE mas_timestep_social_forces
-
-!------------------------------------------------------------------------------!
+          ENDDO
+
+       CASE ( 'walls' )
+
+          srw = scan_radius_wall
+          corner_found = .FALSE.
+!
+!--       Find relevant grid boxes (those that could contain topography within radius)
+          sc_x_start = (x_a - srw) * ddx
+          sc_x_end   = (x_a + srw) * ddx
+          sc_y_start = (y_a - srw) * ddx
+          sc_y_end   = (y_a + srw) * ddx
+          IF ( sc_x_start < nxlg ) sc_x_start = nxlg
+          IF ( sc_x_end   > nxrg ) sc_x_end   = nxrg
+          IF ( sc_y_start < nysg ) sc_y_start = nysg
+          IF ( sc_y_end   > nyng ) sc_y_end   = nyng
+!
+!--       Find "walls" ( i.e. topography steps (up or down) higher than one grid box ) that are
+!--       perpendicular to the agent within the defined search radius. Such obstacles cannot be
+!--       passed and a social force to that effect is applied.
+!--       Walls only apply a force perpendicular to the wall to the agent.
+!--       There is therefore a search for walls directly right, left, south and north of the agent.
+!--       All other walls are ignored.
+!--
+!--       Check for wall left of current agent
+          ij_dum = 0
+          IF ( sc_x_start < ip )  THEN
+             DO  il = ip - 1, sc_x_start, -1
+!
+!--             Going left from the agent, check for a right wall
+                IF ( BTEST( obstacle_flags(jp,il), 2 ) )  THEN
+!
+!--                Obstacle found in grid box il, wall at right side
+                   x_wall = (il+1)*dx
+!
+!--                Calculate force of found wall on agent
+                   CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a, y_a )
+!
+!--                Calculate new x starting index for later scan for corners
+                   ij_dum = il + 1
+                   EXIT
+                ENDIF
+             ENDDO
+          ENDIF
+          IF ( ij_dum /= 0 ) sc_x_start = ij_dum
+
+!
+!--       Check for wall right of current agent
+          ij_dum = 0
+          IF ( sc_x_end > ip )  THEN
+             DO  il = ip + 1, sc_x_end
+!
+!--             Going right from the agent, check for a left wall
+                IF ( BTEST( obstacle_flags(jp,il), 6 ) )  THEN
+!
+!--                Obstacle found in grid box il, wall at left side
+                   x_wall = il*dx
+!
+!--                Calculate force of found wall on agent
+                   CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a, y_a )
+!
+!--                Calculate new x end index for later scan for corners
+                   ij_dum = il - 1
+                   EXIT
+                ENDIF
+             ENDDO
+          ENDIF
+          IF ( ij_dum /= 0 ) sc_x_end = ij_dum
+
+!
+!--          Check for wall south of current agent
+          ij_dum = 0
+          IF ( sc_y_start < jp )  THEN
+             DO  jl = jp - 1, sc_y_start, -1
+!
+!--             Going south from the agent, check for a north wall
+                IF ( BTEST( obstacle_flags(jl,ip), 0 ) )  THEN
+!
+!--                Obstacle found in grid box jl, wall at left side
+                   y_wall = ( jl + 1 ) * dy
+
+                   CALL mas_timestep_wall_corner_force( x_a, x_a, y_a, y_wall )
+!
+!--                Calculate new y starting index for later scan for corners
+                   ij_dum = jl + 1
+                   EXIT
+                ENDIF
+             ENDDO
+          ENDIF
+          IF ( ij_dum /= 0 ) sc_y_start = ij_dum
+
+!
+!--       Check for wall north of current agent
+          ij_dum = 0
+          IF ( sc_y_end > jp )  THEN
+             DO  jl = jp + 1, sc_y_end
+!
+!--             Going north from the agent, check for a south wall
+                IF ( BTEST( obstacle_flags(jl,ip), 4 ) )  THEN
+!
+!--                   obstacle found in grid box jl, wall at left side
+                   y_wall = jl * dy
+
+                   CALL mas_timestep_wall_corner_force( x_a, x_a, y_a, y_wall )
+!
+!--                Calculate new y end index for later scan for corners
+                   ij_dum = jl - 1
+                ENDIF
+             ENDDO
+          ENDIF
+          IF ( ij_dum /= 0 ) sc_y_end = ij_dum
+
+!
+!--       Scan for corners surrounding current agent.
+!--       Only gridcells that are closer than the closest wall in each direction (n,s,r,l) are
+!--       considered in the search since those further away would have a significantly smaller
+!--       resulting force than the closer wall.
+          DO  il = sc_x_start, sc_x_end
+             DO  jl = sc_y_start, sc_y_end
+                IF ( il == ip  .OR.  jl == jp )  CYCLE
+!
+!--             Corners left of agent
+                IF ( il < ip )  THEN
+!
+!--                South left quadrant: look for north right corner
+                   IF ( jl < jp )  THEN
+                      IF ( BTEST( obstacle_flags(jl,il), 1 ) )  THEN
+!
+!--                      Calculate coordinates of the found corner
+                         x_wall = ( il + 1 ) * dx
+                         y_wall = ( jl + 1 ) * dy
+
+                         CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a, y_wall )
+
+                      ENDIF
+!
+!--                North left quadrant: look for south right corner
+                   ELSEIF ( jl > jp )  THEN
+                      IF ( BTEST( obstacle_flags(jl,il), 3 ) )  THEN
+!
+!--                      Calculate coordinates of the corner of mentioned gridcell that is closest
+!--                      to the current agent.
+                         x_wall = ( il + 1 ) * dx
+                         y_wall = jl * dy
+
+                         CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a, y_wall )
+
+                      ENDIF
+                   ENDIF
+                ELSEIF ( il > ip )  THEN
+!
+!--                South right quadrant: look for north left corner
+                   IF ( jl < jp )  THEN
+                      IF ( BTEST( obstacle_flags(jl,il), 7 ) )  THEN
+!
+!--                      Calculate coordinates of the corner of mentioned gridcell that is closest
+!--                      to the current agent.
+                         x_wall = il * dx
+                         y_wall = ( jl + 1 ) * dy
+
+                         CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a, y_wall )
+
+                      ENDIF
+!
+!--                North right quadrant: look for south left corner
+                   ELSEIF ( jl > jp )  THEN
+                      IF ( BTEST( obstacle_flags(jl,il), 5 ) )  THEN
+!
+!--                      Calculate coordinates of the corner of mentioned gridcell that is closest
+!--                      to the current agent.
+                         x_wall = il * dx
+                         y_wall = jl * dy
+
+                         CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a, y_wall )
+
+                      ENDIF
+                   ENDIF
+                ENDIF
+             ENDDO
+          ENDDO
+
+       CASE DEFAULT
+
+    END SELECT
+
+ END SUBROUTINE mas_timestep_social_forces
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Given a distance to the current agent, calculates the force a found corner
-!> or wall exerts on that agent
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_timestep_wall_corner_force( xa, xw, ya, yw )
-
-       IMPLICIT NONE
-
-       REAL(wp) ::  dist_l     !< distance to obstacle
-       REAL(wp) ::  force_d_x  !< increment of social force, x-direction
-       REAL(wp) ::  force_d_y  !< increment of social force, x-direction
-       REAL(wp) ::  xa         !< x-position of agent
-       REAL(wp) ::  xw         !< x-position of wall
-       REAL(wp) ::  ya         !< x-position of agent
-       REAL(wp) ::  yw         !< y-position of wall
-
-       force_d_x = 0.0_wp
-       force_d_y = 0.0_wp
-!
-!--    calculate coordinates of corner relative to agent 
-!--    postion and distance between corner and agent
-       xw = xa - xw
-       yw = ya - yw
-       dist_l = SQRT( (xw)**2 + (yw)**2 )
-!
-!--    calculate x and y component of repulsive force 
-!--    induced by previously found corner
-       IF ( dist_l > 0 ) THEN
-          force_d_x = repuls_wall * d_sigma_rep_wall         &
-                      * EXP( -dist_l * d_sigma_rep_wall )      &
-                      * xw / (dist_l)
-          force_d_y = repuls_wall * d_sigma_rep_wall         &
-                      * EXP( -dist_l * d_sigma_rep_wall )      &
-                      * yw / (dist_l)
-       ENDIF
-
-! !--    forces that are located outside of a sight radius of 
+!> Given a distance to the current agent, calculates the force a found corner or wall exerts on that
+!> agent
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_timestep_wall_corner_force( xa, xw, ya, yw )
+
+    IMPLICIT NONE
+
+    REAL(wp) ::  dist_l     !< distance to obstacle
+    REAL(wp) ::  force_d_x  !< increment of social force, x-direction
+    REAL(wp) ::  force_d_y  !< increment of social force, x-direction
+    REAL(wp) ::  xa         !< x-position of agent
+    REAL(wp) ::  xw         !< x-position of wall
+    REAL(wp) ::  ya         !< x-position of agent
+    REAL(wp) ::  yw         !< y-position of wall
+
+    force_d_x = 0.0_wp
+    force_d_y = 0.0_wp
+!
+!-- Calculate coordinates of corner relative to agent postion and distance between corner and agent.
+    xw = xa - xw
+    yw = ya - yw
+    dist_l = SQRT( ( xw )**2 + ( yw )**2 )
+!
+!-- Calculate x and y component of repulsive force induced by previously found corner
+    IF ( dist_l > 0 )  THEN
+       force_d_x = repuls_wall * d_sigma_rep_wall                                                  &
+                   * EXP( -dist_l * d_sigma_rep_wall )                                             &
+                   * xw / (dist_l)
+       force_d_y = repuls_wall * d_sigma_rep_wall                                                  &
+                   * EXP( -dist_l * d_sigma_rep_wall )                                             &
+                   * yw / (dist_l)
+    ENDIF
+
+! !--    forces that are located outside of a sight radius of
 ! !--    200 degrees (-> COS(100./180.*pi) = COS(.555*pi)) of
 ! !--    current agent are considered to have an effect of 50%
@@ -4586,207 +4414,198 @@
 
 !
-!--    add force increment to total force of current agent
-       force_x = force_x + force_d_x
-       force_y = force_y + force_d_y
-
-    END SUBROUTINE mas_timestep_wall_corner_force
-
-!
-!-- Calculates distance of point P to edge (A,B). If A = B, calculates
-!-- point-to-point distance from A/B to P
-    FUNCTION dist_point_to_edge ( a_x, a_y, b_x, b_y, p_x, p_y )
-
-       IMPLICIT NONE
-
-       REAL(wp)  :: ab_x                !< x-coordinate of vector from A to B
-       REAL(wp)  :: ab_y                !< y-coordinate of vector from A to B
-       REAL(wp)  :: ab_d                !< inverse length of vector from A to B
-       REAL(wp)  :: ab_u_x              !< x-coordinate of vector with direction of ab and length 1
-       REAL(wp)  :: ab_u_y              !< y-coordinate of vector with direction of ab and length 1
-       REAL(wp)  :: ba_x                !< x-coordinate of vector from B to A
-       REAL(wp)  :: ba_y                !< y-coordinate of vector from B to A
-       REAL(wp)  :: ap_x                !< x-coordinate of vector from A to P
-       REAL(wp)  :: ap_y                !< y-coordinate of vector from A to P
-       REAL(wp)  :: bp_x                !< x-coordinate of vector from B to P
-       REAL(wp)  :: bp_y                !< y-coordinate of vector from B to P
-       REAL(wp)  :: a_x                 !< x-coordinate of point A of edge
-       REAL(wp)  :: a_y                 !< y-coordinate of point A of edge
-       REAL(wp)  :: b_x                 !< x-coordinate of point B of edge
-       REAL(wp)  :: b_y                 !< y-coordinate of point B of edge
-       REAL(wp)  :: p_x                 !< x-coordinate of point P
-       REAL(wp)  :: p_y                 !< y-coordinate of point P
-       REAL(wp)  :: dist_x              !< x-coordinate of point P
-       REAL(wp)  :: dist_y              !< y-coordinate of point P
-       REAL(wp)  :: dist_point_to_edge  !< y-coordinate of point P
-
-       ab_x = - a_x + b_x
-       ab_y = - a_y + b_y
-       ba_x = - b_x + a_x 
-       ba_y = - b_y + a_y 
-       ap_x = - a_x + p_x
-       ap_y = - a_y + p_y
-       bp_x = - b_x + p_x
-       bp_y = - b_y + p_y
-
-       IF ( ab_x * ap_x + ab_y * ap_y <= 0. ) THEN
-          dist_point_to_edge = SQRT((a_x - p_x)**2 + (a_y - p_y)**2)
-       ELSEIF ( ba_x * bp_x + ba_y * bp_y <= 0. ) THEN
-          dist_point_to_edge = SQRT((b_x - p_x)**2 + (b_y - p_y)**2)
-       ELSE
-          ab_d = 1./SQRT((ab_x)**2+(ab_y)**2)
-          ab_u_x = ab_x*ab_d
-          ab_u_y = ab_y*ab_d
-          dist_x = ap_x - (ap_x*ab_u_x+ap_y*ab_u_y)*ab_u_x
-          dist_y = ap_y - (ap_x*ab_u_x+ap_y*ab_u_y)*ab_u_y
-          dist_point_to_edge = SQRT( dist_x**2 + dist_y**2 )
+!-- Add force increment to total force of current agent
+    force_x = force_x + force_d_x
+    force_y = force_y + force_d_y
+
+ END SUBROUTINE mas_timestep_wall_corner_force
+
+
+!
+!-- Calculates distance of point P to edge (A,B). If A = B, calculates point-to-point distance from
+!-- A/B to P.
+ FUNCTION dist_point_to_edge( a_x, a_y, b_x, b_y, p_x, p_y )
+
+    IMPLICIT NONE
+
+    REAL(wp)  :: a_x                 !< x-coordinate of point A of edge
+    REAL(wp)  :: a_y                 !< y-coordinate of point A of edge
+    REAL(wp)  :: ab_x                !< x-coordinate of vector from A to B
+    REAL(wp)  :: ab_y                !< y-coordinate of vector from A to B
+    REAL(wp)  :: ab_d                !< inverse length of vector from A to B
+    REAL(wp)  :: ab_u_x              !< x-coordinate of vector with direction of ab and length 1
+    REAL(wp)  :: ab_u_y              !< y-coordinate of vector with direction of ab and length 1
+    REAL(wp)  :: ap_x                !< x-coordinate of vector from A to P
+    REAL(wp)  :: ap_y                !< y-coordinate of vector from A to P
+    REAL(wp)  :: b_x                 !< x-coordinate of point B of edge
+    REAL(wp)  :: b_y                 !< y-coordinate of point B of edge
+    REAL(wp)  :: ba_x                !< x-coordinate of vector from B to A
+    REAL(wp)  :: ba_y                !< y-coordinate of vector from B to A
+    REAL(wp)  :: bp_x                !< x-coordinate of vector from B to P
+    REAL(wp)  :: bp_y                !< y-coordinate of vector from B to P
+    REAL(wp)  :: dist_x              !< x-coordinate of point P
+    REAL(wp)  :: dist_y              !< y-coordinate of point P
+    REAL(wp)  :: dist_point_to_edge  !< y-coordinate of point P
+    REAL(wp)  :: p_x                 !< x-coordinate of point P
+    REAL(wp)  :: p_y                 !< y-coordinate of point P
+
+    ab_x = - a_x + b_x
+    ab_y = - a_y + b_y
+    ba_x = - b_x + a_x
+    ba_y = - b_y + a_y
+    ap_x = - a_x + p_x
+    ap_y = - a_y + p_y
+    bp_x = - b_x + p_x
+    bp_y = - b_y + p_y
+
+    IF ( ab_x * ap_x + ab_y * ap_y <= 0. )  THEN
+       dist_point_to_edge = SQRT( ( a_x - p_x )**2 + ( a_y - p_y )**2 )
+    ELSEIF ( ba_x * bp_x + ba_y * bp_y <= 0. )  THEN
+       dist_point_to_edge = SQRT( ( b_x - p_x )**2 + ( b_y - p_y )**2)
+    ELSE
+       ab_d = 1.0_wp / SQRT( ( ab_x )**2 + ( ab_y )**2 )
+       ab_u_x = ab_x * ab_d
+       ab_u_y = ab_y * ab_d
+       dist_x = ap_x - ( ap_x * ab_u_x + ap_y * ab_u_y ) * ab_u_x
+       dist_y = ap_y - ( ap_x * ab_u_x + ap_y * ab_u_y ) * ab_u_y
+       dist_point_to_edge = SQRT( dist_x**2 + dist_y**2 )
+    ENDIF
+
+ END FUNCTION dist_point_to_edge
+
+!
+!-- Returns the heuristic between points A and B (currently the straight distance)
+ FUNCTION heuristic( ax, ay, bx, by )
+
+    IMPLICIT NONE
+
+    REAL(wp)  :: ax           !< x-coordinate of point A
+    REAL(wp)  :: ay           !< y-coordinate of point A
+    REAL(wp)  :: bx           !< x-coordinate of point B
+    REAL(wp)  :: by           !< y-coordinate of point B
+    REAL(wp)  :: heuristic    !< return value
+
+    heuristic = SQRT( ( ax - bx )**2 + ( ay - by )**2 )
+
+ END FUNCTION heuristic
+
+!
+!-- Calculates if point P is left of the infinite line that contains A and B (direction: A to B).
+!-- Concept: 2D rotation of two vectors
+ FUNCTION is_left( ax, ay, bx, by, px, py )
+
+    IMPLICIT NONE
+
+    LOGICAL  :: is_left !< return value; TRUE if P is left of AB
+
+    REAL(wp)  :: ax     !< x-coordinate of point A
+    REAL(wp)  :: ay     !< y-coordinate of point A
+    REAL(wp)  :: bx     !< x-coordinate of point B
+    REAL(wp)  :: by     !< y-coordinate of point B
+    REAL(wp)  :: px     !< x-coordinate of point P
+    REAL(wp)  :: py     !< y-coordinate of point P
+
+    is_left = (bx-ax)*(py-ay)-(px-ax)*(by-ay) > 0
+    IF ( ( ABS( ax - px ) < .001 .AND. ABS( ay - py ) < .001 )  .OR.                               &
+         ( ABS( bx - px ) < .001 .AND. ABS( by - py ) < .001) )                                    &
+    THEN
+       is_left = .FALSE.
+    ENDIF
+
+ END FUNCTION is_left
+
+!
+!-- Calculates if point P is right of the infinite line that contains A and B (direction: A to B)
+!-- Concept: 2D rotation of two vectors
+ FUNCTION is_right( ax, ay, bx, by, px, py )
+
+    IMPLICIT NONE
+
+    LOGICAL  :: is_right !< return value; TRUE if P is right of AB
+
+    REAL(wp), INTENT(IN)  :: ax     !< x-coordinate of point A
+    REAL(wp), INTENT(IN)  :: ay     !< y-coordinate of point A
+    REAL(wp), INTENT(IN)  :: bx     !< x-coordinate of point B
+    REAL(wp), INTENT(IN)  :: by     !< y-coordinate of point B
+    REAL(wp), INTENT(IN)  :: px     !< x-coordinate of point P
+    REAL(wp), INTENT(IN)  :: py     !< y-coordinate of point P
+
+    is_right = (bx-ax)*(py-ay)-(px-ax)*(by-ay) < 0
+    IF ( ( ABS( ax - px ) < 0.001_wp .AND. ABS( ay - py ) < 0.001_wp )  .OR.                       &
+         ( ABS( bx - px ) < 0.001_wp .AND. ABS( by - py ) < 0.001_wp ) )                           &
+    THEN
+       is_right = .FALSE.
+    ENDIF
+
+ END FUNCTION is_right
+
+!
+!-- Returns true if the line segments AB and PQ share an intersection
+ FUNCTION intersect( ax, ay, bx, by, px, py, qx, qy )
+
+    IMPLICIT NONE
+
+    LOGICAL  :: intersect !< return value; TRUE if intersection was found
+    LOGICAL  :: la        !< T if a is left of PQ
+    LOGICAL  :: lb        !< T if b is left of PQ
+    LOGICAL  :: lp        !< T if p is left of AB
+    LOGICAL  :: lq        !< T if q is left of AB
+    LOGICAL  :: poss      !< flag that indicates if an intersection is still possible
+    LOGICAL  :: ra        !< T if a is right of PQ
+    LOGICAL  :: rb        !< T if b is right of PQ
+    LOGICAL  :: rp        !< T if p is right of AB
+    LOGICAL  :: rq        !< T if q is right of AB
+
+    REAL(wp)  :: ax     !< x-coordinate of point A
+    REAL(wp)  :: ay     !< y-coordinate of point A
+    REAL(wp)  :: bx     !< x-coordinate of point B
+    REAL(wp)  :: by     !< y-coordinate of point B
+    REAL(wp)  :: px     !< x-coordinate of point P
+    REAL(wp)  :: py     !< y-coordinate of point P
+    REAL(wp)  :: qx     !< x-coordinate of point Q
+    REAL(wp)  :: qy     !< y-coordinate of point Q
+
+    intersect = .FALSE.
+    poss      = .FALSE.
+!
+!-- Intersection is possible only if P and Q are on opposing sides of AB
+    lp = is_left(ax,ay,bx,by,px,py)
+    rq = is_right(ax,ay,bx,by,qx,qy)
+    IF ( lp  .AND.  rq )  poss = .TRUE.
+    IF ( .NOT. poss )  THEN
+       lq = is_left(ax,ay,bx,by,qx,qy)
+       rp = is_right(ax,ay,bx,by,px,py)
+       IF ( lq  .AND.  rp )  poss = .TRUE.
+    ENDIF
+!
+!-- Intersection occurs only if above test (poss) was true AND A and B are on opposing sides of PQ.
+    IF ( poss )  THEN
+       la = is_left(px,py,qx,qy,ax,ay)
+       rb = is_right(px,py,qx,qy,bx,by)
+       IF ( la  .AND.  rb )  intersect = .TRUE.
+       IF ( .NOT. intersect )  THEN
+          lb = is_left(px,py,qx,qy,bx,by)
+          ra = is_right(px,py,qx,qy,ax,ay)
+          IF ( lb  .AND.  ra )  intersect = .TRUE.
        ENDIF
-
-    END FUNCTION dist_point_to_edge
-
-!
-!-- Returns the heuristic between points A and B (currently the straight 
-!-- distance)
-    FUNCTION heuristic ( ax, ay, bx, by )
-
-       IMPLICIT NONE
-
-       REAL(wp)  :: ax           !< x-coordinate of point A
-       REAL(wp)  :: ay           !< y-coordinate of point A
-       REAL(wp)  :: bx           !< x-coordinate of point B
-       REAL(wp)  :: by           !< y-coordinate of point B
-       REAL(wp)  :: heuristic    !< return value
-
-       heuristic = SQRT(( ax - bx )**2 + ( ay - by )**2)
-
-    END FUNCTION heuristic 
-
-!
-!-- Calculates if point P is left of the infinite
-!-- line that contains A and B (direction: A to B) 
-!-- Concept: 2D rotation of two vectors
-    FUNCTION is_left ( ax, ay, bx, by, px, py )
-
-       IMPLICIT NONE
-
-       LOGICAL  :: is_left !< return value; TRUE if P is left of AB
-
-       REAL(wp)  :: ax     !< x-coordinate of point A
-       REAL(wp)  :: ay     !< y-coordinate of point A
-       REAL(wp)  :: bx     !< x-coordinate of point B
-       REAL(wp)  :: by     !< y-coordinate of point B
-       REAL(wp)  :: px     !< x-coordinate of point P
-       REAL(wp)  :: py     !< y-coordinate of point P
-
-       is_left = (bx-ax)*(py-ay)-(px-ax)*(by-ay) > 0
-       IF ( (ABS(ax-px) < .001 .AND. ABS(ay-py) < .001) .OR.                  &
-            (ABS(bx-px) < .001 .AND. ABS(by-py) < .001) )                     &
-       THEN
-          is_left = .FALSE.
-       ENDIF
-
-       RETURN
-
-    END FUNCTION is_left 
-
-!
-!-- Calculates if point P is right of the infinite
-!-- line that contains A and B (direction: A to B) 
-!-- Concept: 2D rotation of two vectors
-    FUNCTION is_right ( ax, ay, bx, by, px, py )
-
-       IMPLICIT NONE
-
-       LOGICAL  :: is_right !< return value; TRUE if P is right of AB
-
-       REAL(wp), INTENT(IN)  :: ax     !< x-coordinate of point A
-       REAL(wp), INTENT(IN)  :: ay     !< y-coordinate of point A
-       REAL(wp), INTENT(IN)  :: bx     !< x-coordinate of point B
-       REAL(wp), INTENT(IN)  :: by     !< y-coordinate of point B
-       REAL(wp), INTENT(IN)  :: px     !< x-coordinate of point P
-       REAL(wp), INTENT(IN)  :: py     !< y-coordinate of point P
-
-       is_right = (bx-ax)*(py-ay)-(px-ax)*(by-ay) < 0
-       IF ( (ABS(ax-px) < .001 .AND. ABS(ay-py) < .001) .OR.                  &
-            (ABS(bx-px) < .001 .AND. ABS(by-py) < .001) )                     &
-       THEN
-          is_right = .FALSE.
-       ENDIF
-
-       RETURN
-
-    END FUNCTION is_right 
-
-!
-!-- Returns true if the line segments AB and PQ share an intersection
-    FUNCTION intersect ( ax, ay, bx, by, px, py, qx, qy )
-
-       IMPLICIT NONE
-
-       LOGICAL  :: intersect !< return value; TRUE if intersection was found
-       LOGICAL  :: la        !< T if a is left of PQ
-       LOGICAL  :: lb        !< T if b is left of PQ
-       LOGICAL  :: lp        !< T if p is left of AB
-       LOGICAL  :: lq        !< T if q is left of AB
-       LOGICAL  :: poss      !< flag that indicates if an intersection is still possible
-       LOGICAL  :: ra        !< T if a is right of PQ
-       LOGICAL  :: rb        !< T if b is right of PQ
-       LOGICAL  :: rp        !< T if p is right of AB
-       LOGICAL  :: rq        !< T if q is right of AB
-
-       REAL(wp)  :: ax     !< x-coordinate of point A
-       REAL(wp)  :: ay     !< y-coordinate of point A
-       REAL(wp)  :: bx     !< x-coordinate of point B
-       REAL(wp)  :: by     !< y-coordinate of point B
-       REAL(wp)  :: px     !< x-coordinate of point P
-       REAL(wp)  :: py     !< y-coordinate of point P
-       REAL(wp)  :: qx     !< x-coordinate of point Q
-       REAL(wp)  :: qy     !< y-coordinate of point Q
-
-       intersect = .FALSE.
-       poss      = .FALSE.
-!
-!--    Intersection is possible only if P and Q are on opposing sides of AB
-       lp = is_left(ax,ay,bx,by,px,py)
-       rq = is_right(ax,ay,bx,by,qx,qy)
-       IF ( lp .AND. rq ) poss = .TRUE.
-       IF ( .NOT. poss ) THEN
-          lq = is_left(ax,ay,bx,by,qx,qy)
-          rp = is_right(ax,ay,bx,by,px,py)
-          IF ( lq .AND. rp ) poss = .TRUE.
-       ENDIF
-!
-!--    Intersection occurs only if above test (poss) was true AND
-!--    A and B are on opposing sides of PQ
-       IF ( poss ) THEN
-          la = is_left(px,py,qx,qy,ax,ay)
-          rb = is_right(px,py,qx,qy,bx,by)
-          IF ( la .AND. rb ) intersect = .TRUE.
-          IF ( .NOT. intersect ) THEN
-             lb = is_left(px,py,qx,qy,bx,by)
-             ra = is_right(px,py,qx,qy,ax,ay)
-             IF ( lb .AND. ra ) intersect = .TRUE.
-          ENDIF
-       ENDIF
-
-       RETURN
-
-    END FUNCTION intersect 
+    ENDIF
+
+ END FUNCTION intersect
 
 !
 !-- Gives a nuber randomly distributed around an average
-    FUNCTION random_normal ( avg, variation )
-
-       IMPLICIT NONE
-
-       REAL(wp)  :: avg            !< x-coordinate of vector from A to B
-       REAL(wp)  :: variation      !< y-coordinate of vector from A to B
-       REAL(wp)  :: random_normal  !< y-coordinate of vector from A to B
-
-       REAL(wp), DIMENSION(12)  :: random_arr  !< inverse length of vector from A to B
-
-       CALL RANDOM_NUMBER(random_arr)
-       random_normal = avg + variation*(SUM(random_arr)-6.)
-
-    END FUNCTION random_normal
+ FUNCTION random_normal( avg, variation )
+
+    IMPLICIT NONE
+
+    REAL(wp)  :: avg            !< x-coordinate of vector from A to B
+    REAL(wp)  :: random_normal  !< y-coordinate of vector from A to B
+    REAL(wp)  :: variation      !< y-coordinate of vector from A to B
+
+    REAL(wp), DIMENSION(12)  :: random_arr  !< inverse length of vector from A to B
+
+    CALL RANDOM_NUMBER( random_arr )
+    random_normal = avg + variation * ( SUM( random_arr ) - 6.0_wp )
+
+ END FUNCTION random_normal
 
 
